#include <QtGui>

#include "dialog.h"
#include "vectorhandler.h"
#include "xmlparser.h"

Dialog::Dialog(QWidget *parent)
    : QDialog(parent)
{

    int frameStyle = QFrame::Sunken | QFrame::Panel;
    QSize size(40,40); // used to define icons' sizes
    int i;
    VectorHandler vh;
    items = vh.handle();
    icons = vh.handleIcons();
    stats = vh.handleStats2();
    QString charStats = "";
    charStats += stats[3]+"\n"; // name to first row
    for(i=0;i<12/*stats.count()*/; i++)
    {
        if(i==3) continue; // skipping name
        charStats = charStats + stats[i] + "\n" ; // adding wanted character stats to charStats variable
    }
    int j;
    int k, l;
    QString slotIcon[19];
    QString slotItem[19];
    for(l=0; l<19; l++)
    {
        slotIcon[l]="";
        slotItem[l]="";
        // making sure that all elements are empty
    }
    for(j=0; j<icons.count(); j++)
    {
        if(icons[j].size() < 3)
        {
            k = icons[j].toInt();
            slotIcon[k] = "cache/" + icons[j-1]; //name of the image file
            slotItem[k] = items[j-1];

        }
    }

    QPushButton * slot[19];
    QPushButton * objectPointer;
    signalMapper = new QSignalMapper(this);

    for (i = 0; i < 19; i++)
    {
        // setting up item buttons
        objectPointer = new QPushButton();
        slot[i] = objectPointer;
        slot[i]->setIcon(QIcon(slotIcon[i]));
        slot[i]->setIconSize(size);
        signalMapper->setMapping(slot[i], QString("cache/" + items[i] + "item-tooltip.xml"));
        connect(slot[i], SIGNAL(clicked()), signalMapper, SLOT (map()));

    }
    connect(signalMapper, SIGNAL(mapped(QString)), this, SLOT(informationMessage(QString)));
    // setting up quit button
    QPushButton *quitButton = new QPushButton();
    quitButton->setIcon(QIcon("quit.png"));
    quitButton->setIconSize(size);
    connect(quitButton, SIGNAL(clicked()), this, SLOT(quit()));



    QGridLayout *layout = new QGridLayout;
    layout->setColumnStretch(0, 0);
    layout->setSpacing(0);

    // arranging buttons and textlabel to the grid
    for(i=0; i<8; i++)
    {
        layout->addWidget(slot[i], i, 0);
    }
    for(i=8; i<16; i++)
    {
        layout->addWidget(slot[i], i-8, 6);
    }
    for(i=16; i<19; i++)
    {
        layout->addWidget(slot[i], 7, i-13);
    }
    textLabel = new QLabel;
    layout->addWidget(textLabel, 1, 1, 6, 5);
    textLabel->setText(charStats);
    layout->addWidget(quitButton, 0, 4);

    informationLabel = new QLabel;
    informationLabel->setFrameStyle(frameStyle);

    setLayout(layout);
}


// itemStats in QMessageBox
void Dialog::informationMessage(QString string)
{
    VectorHandler vh;
    QString outString = "";
    items = vh.handleStats(string);
    for(int j=0; j<items.count(); j++)
    {
        if(items[j] == "subclassName" ||
           items[j] == "bonusStamina" || items[j] == "bonusStrength" ||
           items[j] == "armor" || items[j] == "reqiuredLevel" ||
           items[j] == "itemLevel" || items[j] == "bonusDodgeRating" ||
           items[j] == "bonusExpertiseRating" || items[j] == "name" ||
           items[j] == "bonusHitRating" || items[j] == "bonusHasteRating"
             || items[j] == "bonusIntellect"
             || items[j] == "bonusSpirit" || items[j] == "bonusCritRating"
            || items[j] == "class")//{
            items2.append(items[j]);// + " " +items[j+1]);
        if(j<items.count() - 2)
            items2.append(items[j+1]);
    }
    for(int j=0; j<items2.count(); j++)
    {
        outString += items2[j] + "\n";
    }
    QMessageBox::StandardButton reply;
    reply = QMessageBox::information(this, tr("QMessageBox::information()"), outString);
}

void Dialog::quit()
{
    // deleting cache folder before exit
    QDir dir("cache/");
    dir.setFilter(QDir::Files);

    QFileInfoList list = dir.entryInfoList();
    for (int i = 0; i < list.size(); ++i)
    {
        QFileInfo fileInfo = list.at(i);
        dir.remove(fileInfo.fileName());
    }
    dir.rmdir("../cache/");
    exit(1);
}
