#ifndef HTTPWINDOW_H
#define HTTPWINDOW_H

#include <QDialog>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QUrl>

QT_BEGIN_NAMESPACE
class QFile;
class QSslError;
class QNetworkReply;


QT_END_NAMESPACE

class Downloader : public QObject
{
    Q_OBJECT

public:
    Downloader();

    void startRequest(QUrl url, QObject*);
    void downloadFile(QString urlToFetch, QObject*);
    bool isImage;

private slots:
    void httpFinished();
    void setComplete();
signals:
    void downloaderReady();

private:
    QUrl url;
    QNetworkAccessManager qnam;
    QNetworkRequest request;
    QNetworkReply *reply;
    QFile *file;
    int httpGetId;
};

#endif
