#include "startscreen.h"
#include "requesthandlerclass.h"
#include <QtGui>

startScreen::startScreen(QWidget *parent, RequestHandlerClass * handler) : QDialog(parent)
 {
     int frameStyle = QFrame::Sunken | QFrame::Panel;

     this->handler = handler;
     charLabel = new QLabel;
     charLabel->setFrameStyle(frameStyle);
     QPushButton *charButton = new QPushButton(tr("Begin"));
     //creating begin button

     connect(charButton, SIGNAL(clicked()), this, SLOT(setChar()));

     QGridLayout *layout = new QGridLayout;

     layout->addWidget(charButton, 0, 0, 1, 1, Qt::AlignTop);
     // aligning button to top of the screen

     setLayout(layout);

     setWindowTitle(tr("Start Screen"));
 }

void startScreen::setChar()
{
    // staying here until valid xml-file downloaded
    bool ok;
    QString character = QInputDialog::getText(this, tr("QInputDialog::getText()"), tr("Character name:"), QLineEdit::Normal, "", &ok);
    QString realm = QInputDialog::getText(this, tr("QInputDialog::getText()"), tr("Realm:"), QLineEdit::Normal, "", &ok);
    if (ok && !character.isEmpty() && !realm.isEmpty()){
        QString url = "http://eu.wowarmory.com/character-sheet.xml?r=" + realm + "&cn="+ character;
        (*handler).setInstances(1, 0);
        (*handler).download(0, url);
    }
}

