#include <QtGui>

#include "borderlayout.h"
#include "window.h"
#include <iostream>

using namespace std;

Window::Window(QWidget *parent)
{

    createVerticalGroupBox();
    createVerticalGroupBox2();
    createHorizontalGroupBox();

    QTextBrowser *centralWidget = new QTextBrowser;
    centralWidget->setPlainText(tr("Central widget"));

    BorderLayout *layout = new BorderLayout;
    layout->addWidget(centralWidget, BorderLayout::Center);
    layout->addWidget(createLabel("North"), BorderLayout::North);
    //layout->addWidget(createLabel("West"), BorderLayout::West);
    //layout->addWidget(createLabel("East 1"), BorderLayout::East);
    //layout->addWidget(createLabel("South"), BorderLayout::South);

    layout->addWidget(verticalGroupBox2, BorderLayout::East);
    layout->addWidget(verticalGroupBox, BorderLayout::West);
    layout->addWidget(horizontalGroupBox, BorderLayout::South);

    setLayout(layout);

    setWindowTitle(tr("Border Layout"));
}

QLabel *Window::createLabel(const QString &text)
{
    QLabel *label = new QLabel(text);
    label->setFrameStyle(QFrame::Box | QFrame::Raised);
    return label;
}

void Window::createVerticalGroupBox()
 {
     verticalGroupBox = new QGroupBox();
     QVBoxLayout *layoutv = new QVBoxLayout;

     for (int i = 0; i < 8; ++i) {
              buttons[i] = new QPushButton();
              buttons[i]->setIcon(QIcon("inv_helmet_130.jpg"));
              buttons[i]->setIconSize(QSize(51,51));
              layoutv->addWidget(buttons[i]);
          }


     verticalGroupBox->setLayout(layoutv);
 }

void Window::createVerticalGroupBox2()
 {
     verticalGroupBox2 = new QGroupBox();
     QVBoxLayout *layoutv2 = new QVBoxLayout;

     for (int i = 8; i < 16; ++i) {
              buttons[i] = new QPushButton();
              buttons[i]->setIcon(QIcon("inv_helmet_130.jpg"));
              buttons[i]->setIconSize(QSize(51,51));
              layoutv2->addWidget(buttons[i]);
          }


     verticalGroupBox2->setLayout(layoutv2);
 }

void Window::createHorizontalGroupBox()
 {
     horizontalGroupBox = new QGroupBox();
     QHBoxLayout *layouth = new QHBoxLayout;

     for (int i = 16; i < 19; ++i) {
              buttons[i] = new QPushButton();
              buttons[i]->setIcon(QIcon("inv_helmet_130.jpg"));
              buttons[i]->setIconSize(QSize(51,51));
              layouth->addWidget(buttons[i]);
          }


     horizontalGroupBox->setLayout(layouth);
 }

