#include "xmlparser.h"
#include <qstring.h>

bool XmlParser::startDocument()
    {
        return TRUE;
    }
//parsers for item data, because it uses different format
bool XmlParser::characters(const QString &str) {
    if(filePath.contains("item-info.xml") || filePath.contains("item-tooltip.xml")) {
           itemData.append(str);
    }
    return TRUE;
}

//Parser for everything else
//datatype is detected by tagnames
bool XmlParser::startElement( const QString&, const QString&,
                                        const QString& qName,
                                        const QXmlAttributes& attributes)
    {
        if(filePath.contains("item-info.xml") || filePath.contains("item-tooltip.xml")) {
            if(!qName.contains("page") || !qName.contains("itemTooltips") || !qName.contains("itemInfo")) {
                itemData.append(qName);
            }
        }

        else if(filePath.contains("character-sheet.xml")) {

            if(qName.contains("item")) {
                for(i = 0; i < attributes.length(); i++) {
                    if(attributes.localName(i).contains("icon"))
                        icons.append(attributes.value(attributes.localName(i)) + ".jpg");
                    else if(attributes.localName(i) == "id")
                        itemList.append(attributes.value(attributes.localName(i)));
                    if(attributes.localName(i).contains("slot")) {
                        icons.append(attributes.value(attributes.localName(i)));
                        itemList.append(attributes.value(attributes.localName(i)));
                    }
                }
            }
            else if(qName.contains("character") ||
                                qName.contains("health") || qName.contains("strength") || qName.contains("agility")
                            || qName.contains("stamina") || qName.contains("intellect") || qName.contains("spirit")
                            || qName == "armor"/* || qName.contains("resistances") || qName.contains("arcane")
                            || qName.contains("fire") || qName.contains("frost") || qName.contains("holy")
                            || qName.contains("nature") || qName.contains("shadow") || qName.contains("melee") || qName.contains("mainHandDamage")
                            || qName.contains("offHandDamage") || qName.contains("mainHandSpeed") || qName.contains("offHandSpeed")
                            || qName.contains("power") || qName.contains("hitRating") || qName.contains("critChance")
                            || qName.contains("offHandDamage") || qName.contains("mainHandSpeed") || qName.contains("offHandSpeed")
                            || qName.contains("expertise") || qName.contains("ranged") || qName.contains("weaponSkill")
                            || qName.contains("damage") || qName.contains("speed") || qName.contains("spell")
                            || qName.contains("bonusDamage") || qName.contains("pet") || qName.contains("bonusHealing")
                            || qName.contains("manaRegen") || qName.contains("hasteRating") || qName.contains("defenses")
                            || qName.contains("dodge") || qName.contains("parry") || qName.contains("block")
                            || qName.contains("resilience")*/) {
                            for(i = 0; i < attributes.length(); i++)
                                if(attributes.localName(i) == "effective" || attributes.localName(i)=="name" ||
                                   attributes.localName(i) == "class" || attributes.localName(i) == "race" ||
                                   attributes.localName(i) == "faction" || attributes.localName(i) == "level") {
                                if(qName.contains("character"))
                                    stats.append(attributes.localName(i) + ": " + attributes.value(attributes.localName(i)));
                                else
                                    stats.append(qName + ": " + attributes.value(attributes.localName(i)));
                            }
            }
        }
        return TRUE;
    }

bool XmlParser::endElement( const QString&, const QString&, const QString& )
    {
        return TRUE;
    }
